3 # Copyright (c) 2006 Johannes E. Schindelin
7 # This script makes it easy to fix up commits in the middle of a series,
8 # and rearrange commits.
10 # The original idea comes from Eric W. Biederman, in
11 # http://article.gmane.org/gmane.comp.version-control.git/22407
13 # The file containing rebase commands, comments, and empty lines.
14 # This file is created by "git rebase -i" then edited by the user. As
15 # the lines are processed, they are removed from the front of this
16 # file and written to the tail of $done.
17 todo="$state_dir"/git-rebase-todo
19 # The rebase command lines that have already been processed. A line
20 # is moved here when it is first handled, before any associated user
22 done="$state_dir"/done
24 # The commit message that is planned to be used for any changes that
25 # need to be committed following a user interaction.
26 msg="$state_dir"/message
28 # The file into which is accumulated the suggested commit message for
29 # squash/fixup commands. When the first of a series of squash/fixups
30 # is seen, the file is created and the commit message from the
31 # previous commit and from the first squash/fixup commit are written
32 # to it. The commit message for each subsequent squash/fixup commit
33 # is appended to the file as it is processed.
35 # The first line of the file is of the form
36 # # This is a combination of $count commits.
37 # where $count is the number of commits whose messages have been
38 # written to the file so far (including the initial "pick" commit).
39 # Each time that a commit message is processed, this line is read and
40 # updated. It is deleted just before the combined commit is made.
41 squash_msg="$state_dir"/message-squash
43 # If the current series of squash/fixups has not yet included a squash
44 # command, then this file exists and holds the commit message of the
45 # original "pick" commit. (If the series ends without a "squash"
46 # command, then this can be used as the commit message of the combined
47 # commit without opening the editor.)
48 fixup_msg="$state_dir"/message-fixup
50 # $rewritten is the name of a directory containing files for each
51 # commit that is reachable by at least one merge base of $head and
52 # $upstream. They are not necessarily rewritten, but their children
53 # might be. This ensures that commits on merged, but otherwise
54 # unrelated side branches are left alone. (Think "X" in the man page's
56 rewritten="$state_dir"/rewritten
58 dropped="$state_dir"/dropped
61 msgnum="$state_dir"/msgnum
63 # A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
64 # GIT_AUTHOR_DATE that will be used for the commit that is currently
66 author_script="$state_dir"/author-script
68 # When an "edit" rebase command is being processed, the SHA1 of the
69 # commit to be edited is recorded in this file. When "git rebase
70 # --continue" is executed, if there are any staged changes then they
71 # will be amended to the HEAD commit, but only provided the HEAD
72 # commit is still the commit to be edited. When any other rebase
73 # command is processed, this file is deleted.
74 amend="$state_dir"/amend
76 # For the post-rewrite hook, we make a list of rewritten commits and
77 # their new sha1s. The rewritten-pending list keeps the sha1s of
78 # commits that have been processed, but not committed yet,
79 # e.g. because they are waiting for a 'squash' command.
80 rewritten_list="$state_dir"/rewritten-list
81 rewritten_pending="$state_dir"/rewritten-pending
83 GIT_CHERRY_PICK_HELP="$resolvemsg"
84 export GIT_CHERRY_PICK_HELP
86 comment_char=$(git config --get core.commentchar 2>/dev/null | cut -c1)
90 printf '%s\n' "$*" >&2
93 # Output the commit message for the specified commit.
95 git cat-file commit "$1" | sed "1,/^$/d"
98 orig_reflog_action="$GIT_REFLOG_ACTION"
100 comment_for_reflog () {
101 case "$orig_reflog_action" in
103 GIT_REFLOG_ACTION="rebase -i ($1)"
104 export GIT_REFLOG_ACTION
110 mark_action_done () {
111 sed -e 1q < "$todo" >> "$done"
112 sed -e 1d < "$todo" >> "$todo".new
113 mv -f "$todo".new "$todo"
114 new_count=$(git stripspace --strip-comments <"$done" | wc -l)
115 echo $new_count >"$msgnum"
116 total=$(($new_count + $(git stripspace --strip-comments <"$todo" | wc -l)))
118 if test "$last_count" != "$new_count"
120 last_count=$new_count
121 printf "Rebasing (%d/%d)\r" $new_count $total
122 test -z "$verbose" || echo
126 append_todo_help () {
127 git stripspace --comment-lines >>"$todo" <<\EOF
131 r, reword = use commit, but edit the commit message
132 e, edit = use commit, but stop for amending
133 s, squash = use commit, but meld into previous commit
134 f, fixup = like "squash", but discard this commit's log message
135 x, exec = run command (the rest of the line) using shell
137 These lines can be re-ordered; they are executed from top to bottom.
139 If you remove a line here THAT COMMIT WILL BE LOST.
144 sha1_and_parents="$(git rev-list --parents -1 "$1")"
145 case "$sha1_and_parents" in
147 git diff --cc $sha1_and_parents
150 git diff-tree -p "$1^!"
155 esac > "$state_dir"/patch
157 commit_message "$1" > "$msg"
158 test -f "$author_script" ||
159 get_author_ident_from_commit "$1" > "$author_script"
163 echo "$1" > "$state_dir"/stopped-sha
170 echo "$1" > "$state_dir"/stopped-sha
172 git rev-parse --verify HEAD > "$amend"
173 warn "You can amend the commit now, with"
175 warn " git commit --amend"
177 warn "Once you are satisfied with your changes, run"
179 warn " git rebase --continue"
190 test -n "$(git stripspace --strip-comments <"$1")"
194 tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null ||
195 die "$1: not a commit that can be picked")
196 ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null ||
197 ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904)
198 test "$tree" = "$ptree"
203 git rev-parse --verify --quiet "$1"^2 >/dev/null 2>&1
206 # Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
207 # GIT_AUTHOR_DATE exported from the current environment.
210 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
215 git_sequence_editor () {
216 if test -z "$GIT_SEQUENCE_EDITOR"
218 GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
219 if [ -z "$GIT_SEQUENCE_EDITOR" ]
221 GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
225 eval "$GIT_SEQUENCE_EDITOR" '"$@"'
231 case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
232 case "$force_rebase" in '') ;; ?*) ff= ;; esac
233 output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
235 if is_empty_commit "$sha1"
237 empty_args="--allow-empty"
240 test -d "$rewritten" &&
241 pick_one_preserving_merges "$@" && return
242 output git cherry-pick $empty_args $ff "$@"
245 pick_one_preserving_merges () {
256 sha1=$(git rev-parse $sha1)
258 if test -f "$state_dir"/current-commit
260 if test "$fast_forward" = t
262 while read current_commit
264 git rev-parse HEAD > "$rewritten"/$current_commit
265 done <"$state_dir"/current-commit
266 rm "$state_dir"/current-commit ||
267 die "Cannot write current commit's replacement sha1"
271 echo $sha1 >> "$state_dir"/current-commit
273 # rewrite parents; if none were rewritten, we can fast-forward.
275 pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
276 if test "$pend" = " "
280 while [ "$pend" != "" ]
282 p=$(expr "$pend" : ' \([^ ]*\)')
285 if test -f "$rewritten"/$p
287 new_p=$(cat "$rewritten"/$p)
289 # If the todo reordered commits, and our parent is marked for
290 # rewriting, but hasn't been gotten to yet, assume the user meant to
291 # drop it on top of the current HEAD
294 new_p=$(git rev-parse HEAD)
297 test $p != $new_p && fast_forward=f
298 case "$new_parents" in
300 ;; # do nothing; that parent is already there
302 new_parents="$new_parents $new_p"
306 if test -f "$dropped"/$p
309 replacement="$(cat "$dropped"/$p)"
310 test -z "$replacement" && replacement=root
311 pend=" $replacement$pend"
313 new_parents="$new_parents $p"
317 case $fast_forward in
319 output warn "Fast-forward to $sha1"
320 output git reset --hard $sha1 ||
321 die "Cannot fast-forward to $sha1"
324 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
328 # detach HEAD to current parent
329 output git checkout $first_parent 2> /dev/null ||
330 die "Cannot move HEAD to $first_parent"
333 case "$new_parents" in
335 test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
338 author_script_content=$(get_author_ident_from_commit $sha1)
339 eval "$author_script_content"
340 msg_content="$(commit_message $sha1)"
341 # No point in merging the first parent, that's HEAD
342 new_parents=${new_parents# $first_parent}
343 if ! do_with_author output \
344 git merge --no-ff ${strategy:+-s $strategy} -m \
345 "$msg_content" $new_parents
347 printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
348 die_with_patch $sha1 "Error redoing merge $sha1"
350 echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
353 output git cherry-pick "$@" ||
354 die_with_patch $sha1 "Could not pick $sha1"
363 *1[0-9]|*[04-9]) echo "$1"th;;
370 update_squash_messages () {
371 if test -f "$squash_msg"; then
372 mv "$squash_msg" "$squash_msg".bak || exit
374 -e "1s/^. This is a combination of \(.*\) commits\./\1/p" \
375 -e "q" < "$squash_msg".bak)+1))
377 printf '%s\n' "$comment_char This is a combination of $count commits."
378 sed -e 1d -e '2,/^./{
380 }' <"$squash_msg".bak
383 commit_message HEAD > "$fixup_msg" || die "Cannot write $fixup_msg"
386 printf '%s\n' "$comment_char This is a combination of 2 commits."
387 printf '%s\n' "$comment_char The first commit's message is:"
396 printf '%s\n' "$comment_char This is the $(nth_string $count) commit message:"
402 printf '%s\n' "$comment_char The $(nth_string $count) commit message will be skipped:"
404 # Change the space after the comment character to TAB:
405 commit_message $2 | git stripspace --comment-lines | sed -e 's/ / /'
410 peek_next_command () {
411 git stripspace --strip-comments <"$todo" | sed -n -e 's/ .*//p' -e q
414 # A squash/fixup has failed. Prepare the long version of the squash
415 # commit message, then die_with_patch. This code path requires the
416 # user to edit the combined commit message for all commits that have
417 # been squashed/fixedup so far. So also erase the old squash
418 # messages, effectively causing the combined commit to be used as the
419 # new basis for any further squash/fixups. Args: sha1 rest
420 die_failed_squash() {
421 mv "$squash_msg" "$msg" || exit
423 cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
425 warn "Could not apply $1... $2"
429 flush_rewritten_pending() {
430 test -s "$rewritten_pending" || return
431 newsha1="$(git rev-parse HEAD^0)"
432 sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
433 rm -f "$rewritten_pending"
436 record_in_rewritten() {
437 oldsha1="$(git rev-parse $1)"
438 echo "$oldsha1" >> "$rewritten_pending"
440 case "$(peek_next_command)" in
444 flush_rewritten_pending
450 if test "$(git rev-parse HEAD)" = "$squash_onto"
452 # Set the correct commit message and author info on the
453 # sentinel root before cherry-picking the original changes
454 # without committing (-n). Finally, update the sentinel again
455 # to include these changes. If the cherry-pick results in a
456 # conflict, this means our behaviour is similar to a standard
457 # failed cherry-pick during rebase, with a dirty index to
458 # resolve before manually running git commit --amend then git
460 git commit --allow-empty --allow-empty-message --amend \
461 --no-post-rewrite -n -q -C $1 &&
463 git commit --allow-empty --allow-empty-message \
464 --amend --no-post-rewrite -n -q -C $1 ||
465 die_with_patch $1 "Could not apply $1... $2"
468 die_with_patch $1 "Could not apply $1... $2"
473 rm -f "$msg" "$author_script" "$amend" || exit
474 read -r command sha1 rest < "$todo"
476 "$comment_char"*|''|noop)
480 comment_for_reflog pick
483 do_pick $sha1 "$rest"
484 record_in_rewritten $sha1
487 comment_for_reflog reword
490 do_pick $sha1 "$rest"
491 git commit --amend --no-post-rewrite || {
492 warn "Could not amend commit after successfully picking $sha1... $rest"
493 warn "This is most likely due to an empty commit message, or the pre-commit hook"
494 warn "failed. If the pre-commit hook failed, you may need to resolve the issue before"
495 warn "you are able to reword the commit."
496 exit_with_patch $sha1 1
498 record_in_rewritten $sha1
501 comment_for_reflog edit
504 do_pick $sha1 "$rest"
505 warn "Stopped at $sha1... $rest"
506 exit_with_patch $sha1 0
517 comment_for_reflog $squash_style
519 test -f "$done" && has_action "$done" ||
520 die "Cannot '$squash_style' without a previous commit"
523 update_squash_messages $squash_style $sha1
524 author_script_content=$(get_author_ident_from_commit HEAD)
525 echo "$author_script_content" > "$author_script"
526 eval "$author_script_content"
527 if ! pick_one -n $sha1
529 git rev-parse --verify HEAD >"$amend"
530 die_failed_squash $sha1 "$rest"
532 case "$(peek_next_command)" in
534 # This is an intermediate commit; its message will only be
535 # used in case of trouble. So use the long version:
536 do_with_author output git commit --amend --no-verify -F "$squash_msg" ||
537 die_failed_squash $sha1 "$rest"
540 # This is the final command of this squash/fixup group
541 if test -f "$fixup_msg"
543 do_with_author git commit --amend --no-verify -F "$fixup_msg" ||
544 die_failed_squash $sha1 "$rest"
546 cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
547 rm -f "$GIT_DIR"/MERGE_MSG
548 do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e ||
549 die_failed_squash $sha1 "$rest"
551 rm -f "$squash_msg" "$fixup_msg"
554 record_in_rewritten $sha1
557 read -r command rest < "$todo"
559 printf 'Executing: %s\n' "$rest"
560 # "exec" command doesn't take a sha1 in the todo-list.
561 # => can't just use $sha1 here.
562 git rev-parse --verify HEAD > "$state_dir"/stopped-sha
563 ${SHELL:-@SHELL_PATH@} -c "$rest" # Actual execution
565 # Run in subshell because require_clean_work_tree can die.
567 (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
568 if test "$status" -ne 0
570 warn "Execution failed: $rest"
572 warn "and made changes to the index and/or the working tree"
574 warn "You can fix the problem, and then run"
576 warn " git rebase --continue"
578 if test $status -eq 127 # command not found
583 elif test "$dirty" = t
585 warn "Execution succeeded: $rest"
586 warn "but left changes to the index and/or the working tree"
587 warn "Commit or stash your changes, and then run"
589 warn " git rebase --continue"
595 warn "Unknown command: $command $sha1 $rest"
596 fixtodo="Please fix this using 'git rebase --edit-todo'."
597 if git rev-parse --verify -q "$sha1" >/dev/null
599 die_with_patch $sha1 "$fixtodo"
605 test -s "$todo" && return
607 comment_for_reflog finish &&
608 newhead=$(git rev-parse HEAD) &&
611 message="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
612 git update-ref -m "$message" $head_name $newhead $orig_head &&
614 -m "$GIT_REFLOG_ACTION: returning to $head_name" \
618 test ! -f "$state_dir"/verbose ||
619 git diff-tree --stat $orig_head..HEAD
622 test -s "$rewritten_list" &&
623 git notes copy --for-rewrite=rebase < "$rewritten_list" ||
624 true # we don't care if this copying failed
626 if test -x "$GIT_DIR"/hooks/post-rewrite &&
627 test -s "$rewritten_list"; then
628 "$GIT_DIR"/hooks/post-rewrite rebase < "$rewritten_list"
629 true # we don't care if this hook failed
631 rm -rf "$state_dir" &&
633 warn "Successfully rebased and updated $head_name."
645 # skip picking commits whose parents are unchanged
646 skip_unnecessary_picks () {
648 while read -r command rest
650 # fd=3 means we skip the command
651 case "$fd,$command" in
653 # pick a commit whose parent is current $onto -> skip
655 case "$(git rev-parse --verify --quiet "$sha1"^)" in
671 printf '%s\n' "$command${rest:+ }$rest" >&$fd
672 done <"$todo" >"$todo.new" 3>>"$done" &&
673 mv -f "$todo".new "$todo" &&
674 case "$(peek_next_command)" in
676 record_in_rewritten "$onto"
679 die "Could not skip unnecessary pick commands"
682 # Rearrange the todo list that has both "pick sha1 msg" and
683 # "pick sha1 fixup!/squash! msg" appears in it so that the latter
684 # comes immediately after the former, and change "pick" to
686 rearrange_squash () {
687 # extract fixup!/squash! lines and resolve any referenced sha1's
688 while read -r pick sha1 message
691 "squash! "*|"fixup! "*)
692 action="${message%%!*}"
693 rest="${message#*! }"
694 echo "$sha1 $action $rest"
695 # if it's a single word, try to resolve to a full sha1 and
696 # emit a second copy. This allows us to match on both message
698 if test "${rest#* }" = "$rest"; then
699 fullsha="$(git rev-parse -q --verify "$rest" 2>/dev/null)"
700 if test -n "$fullsha"; then
701 # prefix the action to uniquely identify this line as
702 # intended for full sha1 match
703 echo "$sha1 +$action $fullsha"
708 test -s "$1.sq" || return
711 while read -r pick sha1 message
714 *" $sha1 "*) continue ;;
716 printf '%s\n' "$pick $sha1 $message"
718 while read -r squash action msg_content
721 *" $squash "*) continue ;;
727 # full sha1 prefix test
728 case "$msg_content" in "$sha1"*) emit=1;; esac ;;
730 # message prefix test
731 case "$message" in "$msg_content"*) emit=1;; esac ;;
733 if test $emit = 1; then
734 printf '%s\n' "$action $squash $action! $msg_content"
738 done >"$1.rearranged" <"$1"
739 cat "$1.rearranged" >"$1"
740 rm -f "$1.sq" "$1.rearranged"
743 # Add commands after a pick or after a squash/fixup serie
745 add_exec_commands () {
748 while read -r insn rest
756 printf "%s %s\n" "$insn" "$rest"
766 # do we have anything to commit?
767 if git diff-index --cached --quiet HEAD --
769 : Nothing to commit -- skip this
771 if ! test -f "$author_script"
773 die "You have staged changes in your working tree. If these changes are meant to be
774 squashed into the previous commit, run:
778 If they are meant to go into a new commit, run:
782 In both case, once you're done, continue with:
784 git rebase --continue
787 . "$author_script" ||
788 die "Error trying to find the author identity to amend commit"
791 current_head=$(git rev-parse --verify HEAD)
792 test "$current_head" = $(cat "$amend") ||
794 You have uncommitted changes in your working tree. Please, commit them
795 first and then run 'git rebase --continue' again."
796 do_with_author git commit --amend --no-verify -F "$msg" -e ||
797 die "Could not commit staged changes."
799 do_with_author git commit --no-verify -F "$msg" -e ||
800 die "Could not commit staged changes."
804 record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
806 require_clean_work_tree "rebase"
815 git stripspace --strip-comments <"$todo" >"$todo".new
816 mv -f "$todo".new "$todo"
818 git stripspace --comment-lines >>"$todo" <<\EOF
820 You are editing the todo file of an ongoing interactive rebase.
821 To continue rebase after editing, run:
822 git rebase --continue
826 git_sequence_editor "$todo" ||
827 die "Could not execute editor"
833 git var GIT_COMMITTER_IDENT >/dev/null ||
834 die "You need to set your committer info first"
836 comment_for_reflog start
838 if test ! -z "$switch_to"
840 output git checkout "$switch_to" -- ||
841 die "Could not checkout $switch_to"
844 orig_head=$(git rev-parse --verify HEAD) || die "No HEAD?"
845 mkdir "$state_dir" || die "Could not create temporary $state_dir"
847 : > "$state_dir"/interactive || die "Could not mark as interactive"
849 if test t = "$preserve_merges"
851 if test -z "$rebase_root"
853 mkdir "$rewritten" &&
854 for c in $(git merge-base --all $orig_head $upstream)
856 echo $onto > "$rewritten"/$c ||
857 die "Could not init rewritten commits"
860 mkdir "$rewritten" &&
861 echo $onto > "$rewritten"/root ||
862 die "Could not init rewritten commits"
864 # No cherry-pick because our first pass is to determine
865 # parents to rewrite and skipping dropped commits would
866 # prematurely end our probe
869 merges_option="--no-merges --cherry-pick"
872 shorthead=$(git rev-parse --short $orig_head)
873 shortonto=$(git rev-parse --short $onto)
874 if test -z "$rebase_root"
875 # this is now equivalent to ! -z "$upstream"
877 shortupstream=$(git rev-parse --short $upstream)
878 revisions=$upstream...$orig_head
879 shortrevisions=$shortupstream..$shorthead
881 revisions=$onto...$orig_head
882 shortrevisions=$shorthead
884 git rev-list $merges_option --pretty=oneline --abbrev-commit \
885 --abbrev=7 --reverse --left-right --topo-order \
888 while read -r shortsha1 rest
891 if test -z "$keep_empty" && is_empty_commit $shortsha1 && ! is_merge_commit $shortsha1
893 comment_out="$comment_char "
898 if test t != "$preserve_merges"
900 printf '%s\n' "${comment_out}pick $shortsha1 $rest" >>"$todo"
902 sha1=$(git rev-parse $shortsha1)
903 if test -z "$rebase_root"
906 for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
908 if test -f "$rewritten"/$p
916 if test f = "$preserve"
918 touch "$rewritten"/$sha1
919 printf '%s\n' "${comment_out}pick $shortsha1 $rest" >>"$todo"
924 # Watch for commits that been dropped by --cherry-pick
925 if test t = "$preserve_merges"
928 # Save all non-cherry-picked changes
929 git rev-list $revisions --left-right --cherry-pick | \
930 sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
931 # Now all commits and note which ones are missing in
932 # not-cherry-picks and hence being dropped
933 git rev-list $revisions |
936 if test -f "$rewritten"/$rev -a "$(sane_grep "$rev" "$state_dir"/not-cherry-picks)" = ""
938 # Use -f2 because if rev-list is telling us this commit is
939 # not worthwhile, we don't want to track its multiple heads,
940 # just the history of its first-parent for others that will
941 # be rebasing on top of it
942 git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
943 short=$(git rev-list -1 --abbrev-commit --abbrev=7 $rev)
944 sane_grep -v "^[a-z][a-z]* $short" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
950 test -s "$todo" || echo noop >> "$todo"
951 test -n "$autosquash" && rearrange_squash "$todo"
952 test -n "$cmd" && add_exec_commands "$todo"
956 $comment_char Rebase $shortrevisions onto $shortonto
959 git stripspace --comment-lines >>"$todo" <<\EOF
961 However, if you remove everything, the rebase will be aborted.
965 if test -z "$keep_empty"
967 printf '%s\n' "$comment_char Note that empty commits are commented out" >>"$todo"
971 has_action "$todo" ||
972 die_abort "Nothing to do"
974 cp "$todo" "$todo".backup
975 git_sequence_editor "$todo" ||
976 die_abort "Could not execute editor"
978 has_action "$todo" ||
979 die_abort "Nothing to do"
981 test -d "$rewritten" || test -n "$force_rebase" || skip_unnecessary_picks
983 output git checkout $onto || die_abort "could not detach HEAD"
984 git update-ref ORIG_HEAD $orig_head